import { J as Json, O as ObjectStorage, L as LogHandlerOptions, cY as LogMessage, a as LogHandler } from './uuid-59ed0794.js';
export { dy as ArgumentsType, cq as AsyncMutex, cL as AsyncReturnType, _ as BinInput, d as CRYPTO_DEFAULT_ALG, e as CRYPTO_DEFAULT_DERIVE_ALG, f as CRYPTO_DEFAULT_DERIVE_ITERATIONS, C as CRYPTO_DEFAULT_HASH_ALG, d6 as Channel, d5 as ChannelMessageEvent, dk as CryptoEncoder, ay as DAY_MS, aV as Day, aA as DayInput, aU as DayInputLegacy, az as DayValue, a$ as DecimalInput, a_ as DecimalValue, dc as DefaultListener, cg as Disposable, cf as Disposer, ce as DisposerFunction, dd as Emitter, da as EmitterAllHandler, d9 as EmitterHandler, dh as Encoder, J as Json, dj as JsonEncoder, db as ListenerSignature, d7 as LocalChannel, a as LogHandler, L as LogHandlerOptions, cV as LogLevel, cW as LogLevelAlias, cX as LogLevelAliasKey, b as LogLevelAliasType, cY as LogMessage, cU as Logger, c$ as LoggerConsoleHandler, c_ as LoggerContext, cZ as LoggerContextInterface, c as LoggerInterface, d4 as LoggerMemoryHandler, dU as MemStorage, dT as MemStorageOptions, dn as Message, dl as MessageAction, ds as MessageDefinitions, dt as MessageHub, dm as MessageResult, dq as MessagesDefaultMethods, dr as MessagesMethods, dp as MessagesOptions, cp as Mutex, dY as NestedArray, di as NoopEncoder, O as ObjectStorage, cz as Pool, cv as PoolTask, cx as PoolTaskEvents, ct as PoolTaskFn, cw as PoolTaskIdConflictResolution, cu as PoolTaskState, b9 as Primitive, dw as PubSub, dB as RPCFn, dA as RPCOptions, dC as RPCReturn, au as RenderMessagesOptions, dz as ReturnType, bI as RoundingMode, cO as SerialQueue, bT as SortableItem, cN as TaskEvents, cM as TaskFn, ae as Uint8ArrayToHexDump, ad as Uint8ArrayToJson, a2 as Uint8ArrayToString, cl as UseDefer, ci as UseDispose, cd as XRX, a0 as _decodeUtf8Polyfill, $ as _encodeUtf8Polyfill, M as arrayAvg, N as arrayBatches, y as arrayEmptyInPlace, w as arrayFilterInPlace, q as arrayFlatten, s as arrayIntersection, B as arrayIsEqual, H as arrayMax, I as arrayMin, o as arrayMinus, G as arrayRandomElement, u as arrayRemoveElement, v as arraySetElement, E as arrayShuffle, F as arrayShuffleForce, D as arrayShuffleInPlace, z as arraySorted, A as arraySortedNumbers, K as arraySum, t as arraySymmetricDifference, x as arrayToggleInPlace, p as arrayUnion, n as arrayUnique, bv as avg, bt as between, c7 as cloneJsonObject, c6 as cloneObject, bE as cmp, bD as composeOrderby, P as createArray, d8 as createLocalChannelPair, cA as createPromise, du as createPromiseProxy, l as csvParse, m as csvParseToObjects, k as csvStringify, aZ as dateStringToDays, aY as day, aD as dayDay, aT as dayDiff, aH as dayFromAny, aJ as dayFromDate, aK as dayFromDateGMT, aO as dayFromParts, aP as dayFromString, aM as dayFromTimestamp, aG as dayFromToday, aC as dayMonth, aQ as dayMonthStart, aS as dayOffset, aF as dayToDate, aI as dayToDateGMT, aE as dayToParts, aN as dayToString, aL as dayToTimestamp, aB as dayYear, aR as dayYearStart, cQ as debounce, b0 as decimal, b3 as decimalCentsPart, b1 as decimalFromCents, b2 as decimalToCents, U as decodeBase16, R as decodeBase32, W as decodeBase58, Y as decodeBase62, j as decrypt, b4 as deepEqual, b6 as deepMerge, b5 as deepStripUndefinedInPlace, h as deriveKeyPbkdf2, dP as detect, g as digest, c5 as empty, T as encodeBase16, Q as encodeBase32, V as encodeBase58, X as encodeBase62, b$ as encodeQuery, i as encrypt, bV as endSortWeight, c1 as ensureKey, c2 as ensureKeyAsync, ab as equalBinary, b7 as escapeHTML, bH as escapeRegExp, Z as estimateSizeForBase, dG as fetchBasic, dH as fetchJson, dL as fetchOptionsBasicAuth, dJ as fetchOptionsFormURLEncoded, dK as fetchOptionsJson, dI as fetchText, ax as fixBrokenUth8String, aW as forEachDay, ca as forTimes, av as formatMessages, dW as formatMilliseconds, a9 as fromBase64, aa as fromBase64String, ai as fromCamelCase, a6 as fromHex, dO as getGlobal, cR as getGlobalContext, de as getGlobalEmitter, cT as getGlobalLogger, d0 as getNamespaceFilterString, dN as getNavigator, bo as getSecureRandom, bp as getSecureRandomIfPossible, dV as getTimestamp, dM as getWindow, dE as httpMethod, cC as immediate, bc as isArray, bi as isBoolean, dQ as isBrowser, bK as isEven, bJ as isHalf, bg as isInteger, cS as isLocalHost, bj as isNullOrUndefined, bf as isNumber, ba as isObject, bx as isPrime, bw as isPrimeRX, bb as isPrimitive, cJ as isPromise, bd as isRecord, bh as isSafeInteger, be as isString, cG as isTimeout, bk as isUint8Array, a4 as joinToUint8Array, bn as jsonStringify, bm as jsonStringifySafe, bl as jsonStringifySorted, ac as jsonToUint8Array, c4 as last, dg as lazyListener, bZ as linkifyPlainText, c8 as memoize, c9 as memoizeAsync, df as messages, bW as moveSortWeight, bB as objectIsEmpty, bz as objectMap, bA as objectMergeDisposable, dF as parseBasicAuth, dX as parseDate, d2 as parseLogLevel, bC as parseOrderby, c0 as parseQuery, dR as platform, cK as promisify, ei as qid, bq as randomBoolean, bs as randomFloat, br as randomInt, r as randomUint8Array, cc as regExpEscape, cb as regExpString, aw as renderMessages, bM as roundDown, bP as roundHalfAwayFromZero, bQ as roundHalfDown, bR as roundHalfEven, bO as roundHalfOdd, bS as roundHalfTowardsZero, bN as roundHalfUp, bL as roundUp, by as seededRandom, ec as setUuidDefaultEncoding, c3 as size, cB as sleep, bX as sortedItems, bF as sortedOrderby, bU as startSortWeight, aj as stringToBoolean, al as stringToFloat, ak as stringToInteger, a1 as stringToUInt8Array, e8 as suid, e7 as suidBytes, ea as suidBytesDate, e9 as suidDate, bu as sum, cP as throttle, cE as timeout, cD as timeoutReached, cF as timoutError, a7 as toBase64, a8 as toBase64Url, at as toBool, af as toCamelCase, ag as toCapitalize, ah as toCapitalizeWords, aq as toFloat, a5 as toHex, b_ as toHumanReadableUrl, ar as toInt, as as toString, a3 as toUint8Array, bG as toValidFilename, aX as today, cH as tryTimeout, eh as uname, b8 as unescapeHTML, cs as useAsyncMutex, S as useBase, ck as useDefer, ch as useDispose, cj as useDisposer, co as useEventListener, dS as useExitHandler, cn as useInterval, d3 as useLevelFilter, dv as useMessageHub, cr as useMutex, d1 as useNamespaceFilter, cy as usePool, dx as usePubSub, dD as useRPC, bY as useSorted, cm as useTimeout, ed as uuid, eb as uuid32bit, e1 as uuidB32, d_ as uuidB62, dZ as uuidBytes, ee as uuidDecode, e3 as uuidDecodeB32, e0 as uuidDecodeB62, e6 as uuidDecodeV4, ef as uuidEncode, e2 as uuidEncodeB32, d$ as uuidEncodeB62, e5 as uuidEncodeV4, eg as uuidIsValid, e4 as uuidv4, am as valueToBoolean, ao as valueToFloat, an as valueToInteger, ap as valueToString, cI as waitOn } from './uuid-59ed0794.js';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

interface csvOptions {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
}
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): any[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

export { FileStorage, FileStorageOptions, LoggerFileHandler, LoggerNodeHandler, colorString, colorStringList, ensureFolder, exists, getEnvVariableRelaxed, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, stringToPath, toHumanReadableFilePath, toPath, valueToPath, writeText };
